/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.KelompokUser;
import com.portofolio.entity.vo.KelompokUserId;


@Lazy
@Repository
public interface KelompokUserDao extends CrudRepository<KelompokUser, KelompokUserId> {

	@Query(QListAll)
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);

	@Query(QListAll + " and model.namaKelompokUser like %:namaKelompokUser% ")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("namaKelompokUser") String namaKelompokUser, @Param("statusEnabled") boolean statusEnabled,Pageable page);

	@Query(QListAll + " and model.id.kdKelompokUser = :kdKelompokUser")
	Map<String, Object> findByKdKelompokUser(@Param("kdProfile") Integer kdProfile,@Param("kdKelompokUser") Integer kdKelompokUser, @Param("statusEnabled") boolean statusEnabled);

	String QListAll = "select new map("
			+ "model.id.kdKelompokUser as kdKelompokUser"
			+ ", model.id.kdProfile as kdProfile "
			+ ", model.namaKelompokUser as namaKelompokUser "
			+ ", model.reportDisplay as reportDisplay " 
			+ ", model.statusEnabled as statusEnabled "
			+ ", model.noRec as noRec "
			+ ", model.version as version )"
			+ " from KelompokUser model left join model.id id " 
			+ " left join model.profile profile where model.id.kdProfile =:kdProfile and model.statusEnabled = :statusEnabled ";

}